﻿/// <reference path="../Scripts/msls.js" />

window.myapp = msls.application;

(function (lightSwitchApplication) {

    var $Entity = msls.Entity,
        $DataService = msls.DataService,
        $DataWorkspace = msls.DataWorkspace,
        $defineEntity = msls._defineEntity,
        $defineDataService = msls._defineDataService,
        $defineDataWorkspace = msls._defineDataWorkspace,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString;

    function passengerItem(entitySet) {
        /// <summary>
        /// Represents the passengerItem entity type.
        /// </summary>
        /// <param name="entitySet" type="msls.EntitySet" optional="true">
        /// The entity set that should contain this passengerItem.
        /// </param>
        /// <field name="Id" type="Number">
        /// Gets or sets the id for this passengerItem.
        /// </field>
        /// <field name="name" type="String">
        /// Gets or sets the name for this passengerItem.
        /// </field>
        /// <field name="age" type="String">
        /// Gets or sets the age for this passengerItem.
        /// </field>
        /// <field name="Seniorcitizen" type="Boolean">
        /// Gets or sets the seniorcitizen for this passengerItem.
        /// </field>
        /// <field name="CreatedBy" type="String">
        /// Gets or sets the createdBy for this passengerItem.
        /// </field>
        /// <field name="Created" type="Date">
        /// Gets or sets the created for this passengerItem.
        /// </field>
        /// <field name="ModifiedBy" type="String">
        /// Gets or sets the modifiedBy for this passengerItem.
        /// </field>
        /// <field name="Modified" type="Date">
        /// Gets or sets the modified for this passengerItem.
        /// </field>
        /// <field name="RowVersion" type="Array">
        /// Gets or sets the rowVersion for this passengerItem.
        /// </field>
        /// <field name="details" type="msls.application.passengerItem.Details">
        /// Gets the details for this passengerItem.
        /// </field>
        $Entity.call(this, entitySet);
    }

    function ApplicationData(dataWorkspace) {
        /// <summary>
        /// Represents the ApplicationData data service.
        /// </summary>
        /// <param name="dataWorkspace" type="msls.DataWorkspace">
        /// The data workspace that created this data service.
        /// </param>
        /// <field name="passenger" type="msls.EntitySet">
        /// Gets the passenger entity set.
        /// </field>
        /// <field name="details" type="msls.application.ApplicationData.Details">
        /// Gets the details for this data service.
        /// </field>
        $DataService.call(this, dataWorkspace);
    };
    function DataWorkspace() {
        /// <summary>
        /// Represents the data workspace.
        /// </summary>
        /// <field name="ApplicationData" type="msls.application.ApplicationData">
        /// Gets the ApplicationData data service.
        /// </field>
        /// <field name="details" type="msls.application.DataWorkspace.Details">
        /// Gets the details for this data workspace.
        /// </field>
        $DataWorkspace.call(this);
    };

    msls._addToNamespace("msls.application", {

        passengerItem: $defineEntity(passengerItem, [
            { name: "Id", type: Number },
            { name: "name", type: String },
            { name: "age", type: String },
            { name: "Seniorcitizen", type: Boolean },
            { name: "CreatedBy", type: String, isReadOnly: true },
            { name: "Created", type: Date, isReadOnly: true },
            { name: "ModifiedBy", type: String, isReadOnly: true },
            { name: "Modified", type: Date, isReadOnly: true },
            { name: "RowVersion", type: Array }
        ]),

        ApplicationData: $defineDataService(ApplicationData, lightSwitchApplication.rootUri + "/ApplicationData.svc", [
            { name: "passenger", elementType: passengerItem }
        ], [
            {
                name: "passenger_SingleOrDefault", value: function (Id) {
                    return new $DataServiceQuery({ _entitySet: this.passenger },
                        lightSwitchApplication.rootUri + "/ApplicationData.svc" + "/passenger(" + "Id=" + $toODataString(Id, "Int32?") + ")"
                    );
                }
            }
        ]),

        DataWorkspace: $defineDataWorkspace(DataWorkspace, [
            { name: "ApplicationData", type: ApplicationData }
        ])

    });

}(msls.application));
