﻿/// <reference path="data.js" />

(function (lightSwitchApplication) {

    var $Screen = msls.Screen,
        $defineScreen = msls._defineScreen,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString,
        $defineShowScreen = msls._defineShowScreen;

    function AddEditpassengerItem(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the AddEditpassengerItem screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="passengerItem" type="msls.application.passengerItem">
        /// Gets or sets the passengerItem for this screen.
        /// </field>
        /// <field name="details" type="msls.application.AddEditpassengerItem.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "AddEditpassengerItem", parameters);
    }

    function Browsepassenger(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the Browsepassenger screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="passenger" type="msls.VisualCollection" elementType="msls.application.passengerItem">
        /// Gets the passenger for this screen.
        /// </field>
        /// <field name="details" type="msls.application.Browsepassenger.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "Browsepassenger", parameters);
    }

    function ViewpassengerItem(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the ViewpassengerItem screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="passengerItem" type="msls.application.passengerItem">
        /// Gets or sets the passengerItem for this screen.
        /// </field>
        /// <field name="details" type="msls.application.ViewpassengerItem.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "ViewpassengerItem", parameters);
    }

    msls._addToNamespace("msls.application", {

        AddEditpassengerItem: $defineScreen(AddEditpassengerItem, [
            { name: "passengerItem", kind: "local", type: lightSwitchApplication.passengerItem }
        ], [
        ]),

        Browsepassenger: $defineScreen(Browsepassenger, [
            {
                name: "passenger", kind: "collection", elementType: lightSwitchApplication.passengerItem,
                createQuery: function () {
                    return this.dataWorkspace.ApplicationData.passenger;
                }
            }
        ], [
        ]),

        ViewpassengerItem: $defineScreen(ViewpassengerItem, [
            { name: "passengerItem", kind: "local", type: lightSwitchApplication.passengerItem }
        ], [
        ]),

        showAddEditpassengerItem: $defineShowScreen(function showAddEditpassengerItem(passengerItem, options) {
            /// <summary>
            /// Asynchronously navigates forward to the AddEditpassengerItem screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("AddEditpassengerItem", parameters, options);
        }),

        showBrowsepassenger: $defineShowScreen(function showBrowsepassenger(options) {
            /// <summary>
            /// Asynchronously navigates forward to the Browsepassenger screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("Browsepassenger", parameters, options);
        }),

        showViewpassengerItem: $defineShowScreen(function showViewpassengerItem(passengerItem, options) {
            /// <summary>
            /// Asynchronously navigates forward to the ViewpassengerItem screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("ViewpassengerItem", parameters, options);
        })

    });

}(msls.application));
